﻿
namespace Net.Sf.Pkcs11.Wrapper
{
	public enum CKA:uint
	{
		CLASS = PKCS11Constants.CKA_CLASS,
		TOKEN = PKCS11Constants.CKA_TOKEN,
		PRIVATE = PKCS11Constants.CKA_PRIVATE,
		LABEL = PKCS11Constants.CKA_LABEL,
		APPLICATION = PKCS11Constants.CKA_APPLICATION,
		VALUE = PKCS11Constants.CKA_VALUE,
		OBJECT_ID = PKCS11Constants.CKA_OBJECT_ID,
		CERTIFICATE_TYPE = PKCS11Constants.CKA_CERTIFICATE_TYPE,
		ISSUER = PKCS11Constants.CKA_ISSUER,
		SERIAL_NUMBER = PKCS11Constants.CKA_SERIAL_NUMBER,
		AC_ISSUER = PKCS11Constants.CKA_AC_ISSUER,
		OWNER = PKCS11Constants.CKA_OWNER,
		ATTR_TYPES = PKCS11Constants.CKA_ATTR_TYPES,
		TRUSTED = PKCS11Constants.CKA_TRUSTED,
		CERTIFICATE_CATEGORY = PKCS11Constants.CKA_CERTIFICATE_CATEGORY,
		JAVA_MIDP_SECURITY_DOMAIN = PKCS11Constants.CKA_JAVA_MIDP_SECURITY_DOMAIN,
		URL = PKCS11Constants.CKA_URL,
		HASH_OF_SUBJECT_PUBLIC_KEY = PKCS11Constants.CKA_HASH_OF_SUBJECT_PUBLIC_KEY,
		HASH_OF_ISSUER_PUBLIC_KEY = PKCS11Constants.CKA_HASH_OF_ISSUER_PUBLIC_KEY,
		CHECK_VALUE = PKCS11Constants.CKA_CHECK_VALUE,
		KEY_TYPE = PKCS11Constants.CKA_KEY_TYPE,
		SUBJECT = PKCS11Constants.CKA_SUBJECT,
		ID = PKCS11Constants.CKA_ID,
		SENSITIVE = PKCS11Constants.CKA_SENSITIVE,
		ENCRYPT = PKCS11Constants.CKA_ENCRYPT,
		DECRYPT = PKCS11Constants.CKA_DECRYPT,
		WRAP = PKCS11Constants.CKA_WRAP,
		UNWRAP = PKCS11Constants.CKA_UNWRAP,
		SIGN = PKCS11Constants.CKA_SIGN,
		SIGN_RECOVER = PKCS11Constants.CKA_SIGN_RECOVER,
		VERIFY = PKCS11Constants.CKA_VERIFY,
		VERIFY_RECOVER = PKCS11Constants.CKA_VERIFY_RECOVER,
		DERIVE = PKCS11Constants.CKA_DERIVE,
		START_DATE = PKCS11Constants.CKA_START_DATE,
		END_DATE = PKCS11Constants.CKA_END_DATE,
		MODULUS = PKCS11Constants.CKA_MODULUS,
		MODULUS_BITS = PKCS11Constants.CKA_MODULUS_BITS,
		PUBLIC_EXPONENT = PKCS11Constants.CKA_PUBLIC_EXPONENT,
		PRIVATE_EXPONENT = PKCS11Constants.CKA_PRIVATE_EXPONENT,
		PRIME_1 = PKCS11Constants.CKA_PRIME_1,
		PRIME_2 = PKCS11Constants.CKA_PRIME_2,
		EXPONENT_1 = PKCS11Constants.CKA_EXPONENT_1,
		EXPONENT_2 = PKCS11Constants.CKA_EXPONENT_2,
		COEFFICIENT = PKCS11Constants.CKA_COEFFICIENT,
		PRIME = PKCS11Constants.CKA_PRIME,
		SUBPRIME = PKCS11Constants.CKA_SUBPRIME,
		BASE = PKCS11Constants.CKA_BASE,
		PRIME_BITS = PKCS11Constants.CKA_PRIME_BITS,
		SUBPRIME_BITS = PKCS11Constants.CKA_SUBPRIME_BITS,
		VALUE_BITS = PKCS11Constants.CKA_VALUE_BITS,
		VALUE_LEN = PKCS11Constants.CKA_VALUE_LEN,
		EXTRACTABLE = PKCS11Constants.CKA_EXTRACTABLE,
		LOCAL = PKCS11Constants.CKA_LOCAL,
		NEVER_EXTRACTABLE = PKCS11Constants.CKA_NEVER_EXTRACTABLE,
		ALWAYS_SENSITIVE = PKCS11Constants.CKA_ALWAYS_SENSITIVE,
		KEY_GEN_MECHANISM = PKCS11Constants.CKA_KEY_GEN_MECHANISM,
		MODIFIABLE = PKCS11Constants.CKA_MODIFIABLE,
		ECDSA_PARAMS = PKCS11Constants.CKA_ECDSA_PARAMS,
		EC_PARAMS = PKCS11Constants.CKA_EC_PARAMS,
		EC_POINT = PKCS11Constants.CKA_EC_POINT,
		SECONDARY_AUTH = PKCS11Constants.CKA_SECONDARY_AUTH,
		AUTH_PIN_FLAGS = PKCS11Constants.CKA_AUTH_PIN_FLAGS,
		ALWAYS_AUTHENTICATE = PKCS11Constants.CKA_ALWAYS_AUTHENTICATE,
		WRAP_WITH_TRUSTED = PKCS11Constants.CKA_WRAP_WITH_TRUSTED,
		HW_FEATURE_TYPE = PKCS11Constants.CKA_HW_FEATURE_TYPE,
		RESET_ON_INIT = PKCS11Constants.CKA_RESET_ON_INIT,
		HAS_RESET = PKCS11Constants.CKA_HAS_RESET,
		PIXEL_X = PKCS11Constants.CKA_PIXEL_X,
		PIXEL_Y = PKCS11Constants.CKA_PIXEL_Y,
		RESOLUTION = PKCS11Constants.CKA_RESOLUTION,
		CHAR_ROWS = PKCS11Constants.CKA_CHAR_ROWS,
		CHAR_COLUMNS = PKCS11Constants.CKA_CHAR_COLUMNS,
		COLOR = PKCS11Constants.CKA_COLOR,
		BITS_PER_PIXEL = PKCS11Constants.CKA_BITS_PER_PIXEL,
		CHAR_SETS = PKCS11Constants.CKA_CHAR_SETS,
		ENCODING_METHODS = PKCS11Constants.CKA_ENCODING_METHODS,
		MIME_TYPES = PKCS11Constants.CKA_MIME_TYPES,
		MECHANISM_TYPE = PKCS11Constants.CKA_MECHANISM_TYPE,
		REQUIRED_CMS_ATTRIBUTES = PKCS11Constants.CKA_REQUIRED_CMS_ATTRIBUTES,
		DEFAULT_CMS_ATTRIBUTES = PKCS11Constants.CKA_DEFAULT_CMS_ATTRIBUTES,
		SUPPORTED_CMS_ATTRIBUTES = PKCS11Constants.CKA_SUPPORTED_CMS_ATTRIBUTES,
		WRAP_TEMPLATE = PKCS11Constants.CKA_WRAP_TEMPLATE,
		UNWRAP_TEMPLATE = PKCS11Constants.CKA_UNWRAP_TEMPLATE,
		ALLOWED_MECHANISMS = PKCS11Constants.CKA_ALLOWED_MECHANISMS,
		VENDOR_DEFINED = PKCS11Constants.CKA_VENDOR_DEFINED,
        GOSTR3410PARAMS = PKCS11Constants.CKA_GOSTR3410PARAMS
	}
}

